function c = find_clique_plus_one(bnet, f, parent)
%
% Find the lightest clique containing fam(f) U {parent}
% c = find_clique_containing(bnet, f, parent)

cs1 = bnet.jtree.cliques_containing_family{f};
cs2 = bnet.jtree.cliques_containing_node{parent};
cs = intersect(cs1, cs2);
weights = bnet.jtree.clique_sizes(cs);
if ~isempty(cs)
  c = cs(argmin(weights));
else
  c = -1;
end
