function [determined, val] = determine_value_bnode(bnode, bnet)
% DETERMINE_VALUE_BNODE (Dispatch) Determine the value of this node, if possible
% [determined, val] = determine_value_bnode(bnode, bnet)
%
% If determined = 0, val =  []

switch bnode.type
  case 'adder',
    [determined, val] = determine_value_adder(bnode, bnet);
  case 'mux',
    [determined, val] = determine_value_mux(bnode, bnet);
  case 'mux2',
    [determined, val] = determine_value_mux2(bnode, bnet);
  otherwise, 
    %error(['bad type' bnode.type]);
    determined = 0;
    val = [];
end

 
