function bnode = mk_deterministic_node(bnet, self, fname, inputs)
% MK_DETERMINISTIC_NODE Make a deterministic node
% bnode = mk_deterministic_node(bnet, self, fname, inputs)
%
% self = f(x1, x2, ..., xn) with probability 1, where the xi are the parents.
% inputs contains the node numbers corresponding to the arguments.
%
% We convert the function into a CPT once the evidence has arrived.

bnode.type = 'deterministic';
bnode.self = self;
bnode.parents = parents(bnet.adj_mat, self);
bnode.inputs = inputs;
bnode.fname = fname;
bnode.self_size = bnet.node_sizes(self);
bnode.nparams = 0; % since deterministic
bnode.adjustable = 0;
