function t = prod_CPT_and_pi_msgs_mux(bnode, bnet, except, except_val)

% t(x) = sum_{uk, k ~= i} P(x|u) prod_{k ~= i} pi_from(uk)
% where i = except

n = bnode.self;
ninputs = length(bnode.input);
X = bnode.self_size;
t = zeros(X,1);
j = bnet.pearl.parent_index{n}(bnode.gate); % gate is my j'th parent
m = bnet.pearl.msg{n}.pi_from_parent{j};
pi_from_gate = m(:);
pi_from_inputs = zeros(ninputs, 1);
for x=1:X
  for i=1:ninputs
    j = bnet.pearl.parent_index{n}(bnode.input(i)); % the i'th input is my j'th parent
    m = bnet.pearl.msg{n}.pi_from_parent{j};
    pi_from_inputs(i) = m(x);
  end
  if except ~= -1
    pi_from_inputs(except) = (x==except_val);
  end
  t(x) = sum(pi_from_inputs .* pi_from_gate);
end
