function bnode = randomize_params_bnode(bnode)
% RANDOMIZE_PARAMS_BNODE (Dispatch) Set the parameters of a generic node to random values.
% bnode = randomize_params_bnode(bnode)

switch bnode.type
  case 'gaussian', 
    bnode = randomize_params_gaussian(bnode);
  case 'logistic', 
    bnode = randomize_params_logistic(bnode);
  case 'input',
    bnode = randomize_params_input(bnode);
  case 'noisyfn',
    bnode = randomize_params_noisyfn(bnode);
  case 'noisyor',
    bnode = randomize_params_noisyor(bnode);
  case 'softmax', 
    bnode = randomize_params_softmax(bnode);
  case 'tabular',
    bnode = randomize_params_tabular(bnode);
  otherwise,
    error(['bad type' bnode.type]);
end

 
