function bnode = reset_ess_bnode(bnode)
% RESET_ESS_BNODE (Dispatch) Reset the Expected Sufficient Statistics for a generic node.
% bnode = reset_ess_bnode(bnode)

switch bnode.type
  case 'gaussian',
    bnode = reset_ess_gaussian(bnode);
  case 'input',
    bnode = reset_ess_input(bnode);
  case 'logistic',
    bnode = reset_ess_logistic(bnode);
  case 'noisyfn',
    bnode = reset_ess_noisyfn(bnode);
  case 'noisyor',
    bnode = reset_ess_noisyor(bnode);
  case 'softmax',
    bnode = reset_ess_softmax(bnode);
  case 'tabular',
    bnode = reset_ess_tabular(bnode);
  otherwise,
    error(['bad type' bnode.type]);
end

 
