function bnode = update_ess_bnode(bnode, m)
% UPDATE_ESS_GAUSSIAN (Dispatch) Update the Expected Sufficient Statistics with a new observation for a generic node.
% bnode = update_ess_bnode(bnode, marginal)

switch bnode.type
  case 'gaussian', 
    bnode = update_ess_gaussian(bnode, m);
  case 'input',
    bnode = update_ess_input(bnode, m);
  case 'logistic', 
    bnode = update_ess_logistic(bnode, m);
  case 'noisyfn',
    bnode = update_ess_noisyfn(bnode, m);
  case 'noisyor',
    bnode = update_ess_noisyor(bnode, m);
  case 'softmax', 
    bnode = update_ess_softmax(bnode, m);
  case 'tabular',
    bnode = update_ess_tabular(bnode, m);
  otherwise,
    error(['bad type' bnode.type]);
end

 
