Consider the following graphical model, where all nodes are linear Gaussian:

      A
   X1 -> X2 (Q)
 C |     | 
   v     v
   Y1    Y2 (R)

This encodes the following equations:
   x(t+1) = A*x(t) + w(t),  w ~ N(0, Q),  x(0) ~ N(init_x, init_V)
   y(t)   = C*x(t) + v(t),  v ~ N(0, R)

This is variously called a Kalman filter model, a state space model,
or a linear dynamical system. For more details, see the following papers:

Inference (Kalman smoother)
- Bar-Shalom and Li, "Estimation and Tracking", 1983

Learning (EM)
 - Ghahramani and Hinton, "Parameter Estimation for LDS", tech. report, 1996
 - Digalakis, Rohlicek and Ostendorf, "ML Estimation of a stochastic linear system with the EM
      algorithm and its application to speech recognition",
       IEEE Trans. Speech and Audio Proc., 1(4):431--442, 1993.
- Roweis and Ghahramani, "A unifying review of linear Gaussian models", submitted, 1997



A switching Kalman filter model (SKF) has a different set of matrices
for each value of a hidden switch variable. For details, see

- Kevin Murphy, "Switching Kalman Filters", tech. report, 1998.
- Zoubin Ghahramani, "Switching State Space models", submitted, 1998.



An ARMA model (Auto Regressive Moving Average) can be converted to
state space form, and hence we can use the Kalman inference and
learning code. Similarly, we can create switching AR models. See

- James Hamilton, "Time Series Analysis", Princeton Univ. Press, 1994.
