function beta = back_init_belief_state(bnet, scale, obs_nodes)
% BACK_INIT_BELIEF_STATE Compute scaled-beta(:,T) = scale(T) * 1 for a DBN.
% beta = back_init_belief_state(bnet, scale, obs_nodes)
%
% This is a generalization of the HMM equation
% beta(:,T) = scale(T) * ones

bnet.observed_nodes = obs_nodes;
cluster = bnet.dbn.cluster;
num_clusters = length(cluster);
beta = cell(1,num_clusters);
ss = bnet.slice_size;
for c=1:num_clusters
  beta{c} = mk_potential(cluster{c}, bnet);
  %beta{c} = scale_potential(beta{c}, scale);
  % can't normalize if it's a Gaussian canonical potential
end

