function gaussplot(mu, Sigma)
% GAUSSDRAW Plot some contours of constant probability density of a 2D Gaussian distribution.
% gaussdraw(mu, Sigma)

% Modelled afer demgauss from netlab.

ngrid = 40;
cmin = -5; cmax = 10; 
cvals = linspace(cmin, cmax, ngrid);
[X1, X2] = meshgrid(cvals, cvals);
XX = [X1(:), X2(:)];

probs = gauss(mu, Sigma, XX);
probs = reshape(probs, ngrid, ngrid);

fh2 = figure;
contour(X1, X2, probs, 'b');
hold on
