function inter = reveal(data, node_sizes)
% REVEAL Find the best inter-slice matrix of a DBN from a fully-observable time series.
% inter = reveal(data, node_sizes)
%
% data(i,t) is the value of the i'th node at time step t.
%
% See "REVEAL: A general reverse engineering algorithm for inference of genetic network
%   architectures", Liang et al. PSB 98

ss = length(node_sizes);
inter = zeros(ss);
for i=1:ss
  [ps] = find_best_parents_1seq('MI', i, 1:ss, [], [], data, node_sizes);
  inter(ps,i) = 1;
end
