function pot = mk_gpot(members, sizes, subtype)
% MK_GPOT Make a Gaussian potential.
% pot = mk_gpot(members, sizes, type)
%
% type = 'c' means canonical characteristics, 'm' means moment characteristics

pot.domain = members;
pot.sizes = sizes;
n = sum(sizes);
pot.type = 'g';

if subtype=='c'
  pot.subtype = 'c';
  pot.g = 0;
  pot.h = zeros(n,1);
  pot.K = zeros(n,n);
elseif subtype=='m'
  pot.subtype = 'm';
  pot.logp = 0;
  pot.mu = zeros(n,1);
  pot.Sigma = zeros(n,n);
else
  error('bad type');
end
