function P1 = scale_potential(P1, scale)
% SCALE_POTENTIAL (Dispatch) Scale a generic potential.
% P1 = scale_potential(P1, scale)

switch P1.type
  case 'd',
    P1 = scale_table(P1, scale);
  case 'm',
    P1 = scale_max_table(P1, scale);
  case 'g',
    P1 = scale_gpot(P1, scale);
  case 'cg',
    P1 = scale_cgpot(P1, scale);
  otherwise
    error(['bad type ' P1.type]);
end
