% post{1} contains slices 1 and 2, post{2} 2 and 3, ..., post{T-1} T-1 and T
if t==1 & subset(nodes, (1:ss))
  % If we are only doing filtering, we should avoid including the evidence from slice 2
  % so we use post1 instead of post{1}. (If we are smoothing, post1 = post{1} for slice 1.)
  % Also, we must use jtree1 instead of jtree, since intra1 might be different from intra.
  c = find_clique(bnet.jtree1, nodes);
  bigm = bnet.dbn.post1{c};
else
  if t==bnet.num_slices 
    assert(all(nodes<=ss)); % since there are no nodes beyond T
    c = find_clique(bnet.jtree, nodes+ss); % since we will get it from the 2nd slice of T-1, T
    bigm = bnet.dbn.post{t-1}{c};
  else
    c = find_clique(bnet.jtree, nodes);
    bigm = bnet.dbn.post{t}{c};
  end
end
