function pot = mk_pot_from_noisyfn(bnode, bnet)
% MK_POT_FROM_NOISYFN Make a potential from a noisyfn node.
% pot = mk_pot_from_noisyfn(bnode, bnet)
%
% We create the equivalent CPT from the noisyfn node, i.e., we make no attempt
% to exploit the special structure of this node for speeding up inference.
% For details on how to do this, see e.g., Rish and Dechter, "On the impact
% of causal independence", UCI tech report, 1998.

bnode.CPT = mk_CPT_from_noisyfn(bnode.pfail, bnode.fn, bnode.self_size);
pot = mk_pot_from_tabular(bnode, bnet);

