function pot = mk_pot_from_noisyor(bnode, bnet)
% MK_POT_FROM_NOISYOR Make a potential from a noisyor node.
% pot = mk_pot_from_noisyor(bnode, bnet)
%
% We create the equivalent CPT from the noisyor node, i.e., we make no attempt
% to exploit the special structure of this node for speeding up inference.
% For details on how to do this, see e.g., Rish and Dechter, "On the impact
% of causal independence", UCI tech report, 1998.

bnode.CPT = mk_CPT_from_noisyor(bnode.inhibit);
pot = mk_pot_from_tabular(bnode, bnet);

